			list      p=18f452
			#include <p18f452.inc>
;
;  Define the "ISR_Routine" in this file as global so that C files can access them
;  Declare the Variable "Rec_Data" is defined be C file
; 
			global	ISR_Routine
			extern	Var1				; Golbal Variable (Var1) from Assembly
			global	Var2				; Golbal Variable (Var2) from Assembly
			extern	Rec_Data			; External Variable (Rec_Data) from Ex7-2.c
;
;*****  Define Global Variable in Access Bank  ******
;
			udata_acs					; Define Golbal Variable in Access Bank
;Var1		res		1
 Var2		res		1
;
;*****  Program code start at here *******
;
			code		
;
;*****************************
;*    Interrupt subroutine   *
;*****************************
ISR_Routine
 			bcf	PIR1,RCIF,ACCESS	; clear USART interrupt flag (RCIF)
			banksel Rec_Data			; Set correct value to BSR 
			movf	RCREG,W				; Get USART data
			movwf	Rec_Data,BANKED		; Save to Rec_Data varable with BANK SELECTED
			movwf	PORTD				; Display USART data on LEDs
			movwf	Var1 				; Save to Var1 in Access Bank
			movwf	Var2 				; Save to Var2 in Access Bank
			call	Send_USART 		
			retfie 	FAST				; Return with SHADOW swap
 
Send_USART 
			movlw	a'='					; Load "=" to Wreg.
			movwf	TXREG 				; Send to RS-232
			nop
Tx_Loop 	btfss	PIR1,TXIF 			; Check TXIF rising to Hi
			goto 	Tx_Loop				; Is Low, loop test
			bcf		PIR1,TXIF 			; Clear TXIF
			movff	RCREG,TXREG			; Send back the response to RS-232
			return 	 					; Retrun with normal
;
			end
	
